#!/usr/bin/env python
# -*- coding: utf-8 -*-
#gnetdict script 檔範例
#License: GNU General Public License
#Author: 洪任諭 Hong Jen Yee (PCMan) <pcman.tw@gmail.com>

import sys, os, urllib, re

class DictScript:
    def __init__(self):
        self.script_version='1.0'
        self.name='教育部國語辭典'
        self.url='http://140.111.34.46/dict/'
        self.version='0.1'
        self.author='PCMan'

    def get_webpage( self, url ):
        f = urllib.urlopen( url )
        content = f.read()
        f.close()

        #移除表單，因為 gtkhtml2 無法正確顯示
        reg = re.compile( '.*(<FORM(.*\n)*.*</FORM>)', re.MULTILINE | re.IGNORECASE )
        content = reg.sub('', content)
        return content

    #查詢單字，查詢成功把結果網頁內容輸出在 stdout，
    #註：stdout 輸出的第一行需為查詢網頁的 url
    #並且 return True，否則 return False
    def query(self, word):

        codec=unicode(word, 'utf-8')
        word = codec.encode('BIG5')    #轉成 big5
        if word == '':
            return

        url = 'http://140.111.34.46/cgi-bin/dict/newsearch.cgi?QueryScope=Name&QueryCommand=find&GraphicWord=yes&Database=dict&QueryString=' + urllib.quote_plus(word)

        result = self.get_webpage( url )
        if result == '':    #查詢失敗
            return False, None, None
        #查詢成功，把結果輸出到 stdout
        return True, url, result

    #開啟 url，開啟成功把結果網頁內容輸出在 stdout，
    #註：stdout 輸出的第一行需為此網頁的 url
    #並且 return True。禁止連接此 url 則 return False
    def open_url(self, url):
        full_url = 'http://140.111.34.46/cgi-bin/dict/' + url
        content = self.get_webpage(full_url)
        if content != '':
            return True,full_url, content
        return False, None, None

    #快取圖檔，從 url 下載圖片，並快取到本機暫存檔
    #快取成功，把本機暫存擋路徑輸出在 stdout，
    #並且 return True。禁止顯示此圖片則 return False
    def cache_image(self, url):
        basename = os.path.basename(url)

        #快取圖片的目錄
        cache_dir=os.path.expanduser('~/.gnetdict/edudict/')
        if not os.path.exists(cache_dir):    #若不存在則建立
            os.mkdir(cache_dir)

        cache_path = cache_dir + basename

        if not os.path.exists( cache_path ):
            urllib.urlretrieve( 'http://140.111.34.46/' + url, cache_path )
        return True, cache_path    #把本機快取圖檔路徑輸出到stdout
